---
title: IDBFactory.deleteDatabase()
slug: Web/API/IDBFactory/deleteDatabase
tags:
  - API
  - Database
  - IDBFactory
  - IndexedDB
  - Method
  - Reference
  - Storage
  - deleteDatabase
---
<div>{{APIRef("IndexedDB")}}</div>

<p>The <strong><code>deleteDatabase()</code></strong> method of the {{DOMxRef("IDBFactory")}} interface requests the deletion of a database. The method returns an {{DOMxRef("IDBOpenDBRequest")}} object immediately, and performs the deletion operation asynchronously.</p>

<p>If the database is successfully deleted, then a <code>success</code> event is fired on the request object returned from this method, with its <code>result</code> set to <code>undefined</code>. If an error occurs while the database is being deleted, then an <code>error</code> event is fired on the request object that is returned from this method.</p>

<p>When <code>deleteDatabase()</code> is called, any other open connections to this particular database will get a <a href="/en-US/docs/Web/Events/versionchange_indexedDB">versionchange</a> event.</p>

<p>{{AvailableInWorkers}}</p>

<h2 id="Syntax">Syntax</h2>

<p>For the current standard:</p>

<pre class="syntaxbox">var <em>request</em> = <em>indexedDB</em>.deleteDatabase(<em>name</em>);</pre>

<p><span class="idlInterface"><span class="idlMethod">For the experimental version with <code>options</code> (see below):</span></span></p>

<pre class="syntaxbox">var <em>request</em> = <em>indexedDB</em>.deleteDatabase(name, options);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>name</dt>
 <dd>The name of the database you want to delete. Note that attempting to delete a database that doesn't exist does not throw an exception, in contrast to {{DOMxRef("IDBDatabase.deleteObjectStore()")}}, which does throw an exception if the named object store does not exist.</dd>
 <dt>options{{NonStandardBadge}}</dt>
 <dd>In Gecko, since <a href="/en-US/Firefox/Releases/26">version 26</a>, you can include a non-standard optional storage parameter that specifies whether you want to delete a <code>permanent</code> (the default value) IndexedDB, or an indexedDB in <code>temporary</code> storage (aka shared pool.)</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{DOMxRef("IDBOpenDBRequest")}} on which subsequent events related to this request are fired.</p>

<h2 id="Example">Example</h2>

<pre class="brush: js">var DBDeleteRequest = window.indexedDB.deleteDatabase("toDoList");

DBDeleteRequest.onerror = function(event) {
  console.log("Error deleting database.");
};

DBDeleteRequest.onsuccess = function(event) {
  console.log("Database deleted successfully");

  console.log(event.result); // should be undefined
};
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("IndexedDB 2", "#dom-idbfactory-deletedatabase", "deleteDatabase()")}}</td>
   <td>{{Spec2("IndexedDB 2")}}</td>
   <td> </td>
  </tr>
  <tr>
   <td>{{SpecName("IndexedDB", "#dom-idbfactory-deletedatabase", "deleteDatabase()")}}</td>
   <td>{{Spec2("IndexedDB")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.IDBFactory.deleteDatabase")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{DOMxRef("IDBDatabase")}}</li>
 <li>Using transactions: {{DOMxRef("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{DOMxRef("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{DOMxRef("IDBObjectStore")}}</li>
 <li>Using cursors: {{DOMxRef("IDBCursor")}}</li>
 <li>Reference example: <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
</ul>
